-- /run dofile("Interface/Addons/AutoBuffDelete/AutoBuffDelete.lua")


local AddonName    = "AutoBuffDelete"
local AddonVer     = "v1"
local AddonCreator = "Zeus"

AutoBuffDelete = {
  func = {},
  AutoBuffActive = false,
  Buffs = {500127, 506526, 623145, 500673}
};
_G.AutoBuffDelete = AutoBuffDelete;

function AutoBuffDelete.func.AutoBuff_OnLoad(this)
  this:RegisterEvent("UNIT_BUFF_CHANGED")
  this:RegisterEvent("ZONE_CHANGED")
  this:RegisterEvent("PLAYER_ENTER_COMBAT")
  DEFAULT_CHAT_FRAME:AddMessage("|H|h|cffeeeeee" .. AddonName .. " " .. AddonVer .. " (by " .. AddonCreator .. ")|h|r |H|h|cffFFFF00Loaded.|h|r")

end

function AutoBuffDelete.func.AutoBuff_OnEvent(this, event, arg1, arg2)

  if AutoBuffDelete.AutoBuffActive then
    AutoBuffDelete.func.AutoBuff("player")
  end
  if event == "UNIT_BUFF_CHANGED" and arg1 == "player" then
    AutoBuffDelete.func.AutoBuff(arg1)
  end
  if event == "PLAYER_ENTER_COMBAT" then
end
end
SLASH_AutoBuffDelete1 = "/autobuff"
SlashCmdList["AutoBuffDelete"] = function (editBox, msg)
  if AutoBuffDelete.AutoBuffActive then
    AutoBuffDelete.AutoBuffActive = false
    DEFAULT_CHAT_FRAME:AddMessage( "AUTO BUFF DELETE |cffff0000DISABLED|r")
  else
    AutoBuffDelete.AutoBuffActive = true
    DEFAULT_CHAT_FRAME:AddMessage( "AUTO BUFF DELETE |cffFFFF00ENABLED|r" )
  end
end

function AutoBuffDelete.func.AutoBuff(unit)
  if not AutoBuffDelete.AutoBuffActive then
    return
  end

  local mainClass, subClass = UnitClassToken("player");
  if mainClass == "KNIGHT" or
 (mainClass == "HARPSYN" and (subClass == "KNIGHT")) or
 (mainClass == "WARDEN" and (subClass == "KNIGHT")) or
 (mainClass == "WARDEN" and (subClass == "WARRIOR")) or
 (mainClass == "WARDEN" and (subClass == "PSYRON")) or
 (mainClass == "PSYRON" and (subClass == "KNIGHT")) or
 (mainClass == "PSYRON" and (subClass == "WARRIOR")) or
 (mainClass == "PSYRON" and (subClass == "AUGUR"))then
    local i = 1
    repeat
      local _, _, _, buffID = UnitBuff("player", i)
      if buffID then
        for j = 1, #AutoBuffDelete.Buffs do
          if buffID == AutoBuffDelete.Buffs[j] then
            CancelPlayerBuff(i)
            break
          end
        end
      end
      i = i + 1
    until not buffID
  end
end